﻿setDevelopmentMode(true)
local vehsText = {
	showRadius = 20,
	scale = 2,
	owner_color = {255, 255, 100, 255},
	sell_color = {255, 255, 255, 255},
	font = 'default-small'
}

local screenW, screenH = guiGetScreenSize()
local textShowCol




function dxDrawBorderedText( text, x, y, w, h, color, scale, font, alignX, alignY, clip, wordBreak, postGUI )
	dxDrawText ( text, x - 1, y - 1, w - 1, h - 1, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x + 1, y - 1, w + 1, h - 1, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x - 1, y + 1, w - 1, h + 1, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x + 1, y + 1, w + 1, h + 1, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x - 1, y, w - 1, h, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x + 1, y, w + 1, h, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x, y - 1, w, h - 1, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x, y + 1, w, h + 1, tocolor ( 0, 0, 0, 255 ), scale, font, alignX, alignY, clip, wordBreak, false )
	dxDrawText ( text, x, y, w, h, color, scale, font, alignX, alignY, clip, wordBreak, postGUI )
end

addEventHandler ( "onClientRender", root, 
	function()
		if ( textShowCol ) then
			local px, py, pz = getElementPosition(localPlayer)
			local vehTable = getElementsWithinColShape ( textShowCol, "vehicle")
			if vehTable and #vehTable > 0 then
				for i, v in ipairs(vehTable) do
					local x, y, z = getElementPosition(v)
					if ( isElementOnScreen ( v ) and isLineOfSightClear ( px, py, pz+2, x, y, z+1, true, true, true, true, true, false, false, v) ) then
						local sx, sy, dist = getScreenFromWorldPosition ( x, y, z+1.2, 5)
						if sx then
							local curScale = vehsText.scale/(dist*0.15)
							local ownerDataText = getElementData( v, "owner" )
							local priceDataText = getElementData( v, "price" )
							if ( ownerDataText and ownerDataText~="" ) then
								if ( ownerDataText == "Nobody" ) then
									local textW = dxGetTextWidth ( "Цена: $"..tostring(priceDataText), curScale, vehsText.font )
									dxDrawBorderedText( "Цена: $"..tostring(priceDataText),  sx-(textW/2), sy, screenW, screenH, tocolor(unpack(vehsText.sell_color)), curScale, vehsText.font)
								else
									local textW = dxGetTextWidth ( "Владелец: "..tostring(ownerDataText), curScale, vehsText.font )
									dxDrawBorderedText( "Владелец: "..tostring(ownerDataText), sx-(textW/2), sy, screenW, screenH, tocolor(unpack(vehsText.owner_color)), curScale, vehsText.font)
								end
							end
						end
					end
				end
			end
		end
	end
)

addEventHandler ( "onClientPlayerSpawn", localPlayer,
	function()
		local x, y, z = getElementPosition(localPlayer)
		textShowCol = createColCircle ( x, y, vehsText.showRadius )
		attachElements(textShowCol, localPlayer)
	end
)

addEventHandler( "onClientResourceStart", resourceRoot,
	function()
		if ( not textShowCol and getElementHealth ( localPlayer ) > 0 ) then
			local x, y, z = getElementPosition(localPlayer)
			textShowCol = createColCircle ( x, y, vehsText.showRadius )
			attachElements(textShowCol, localPlayer)
		end
	end
)


