﻿function adminSetCarModel ( source, cmd, model )
	if(model) then
		if((tonumber(model) > 399) and (tonumber(model) < 612))then
			local accName = getAccountName ( getPlayerAccount ( source ) )
			if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "SuperModerator" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "Moderator" ) ) then
			    if(isPedInVehicle(source)) then
			   		local playercar = getPedOccupiedVehicle ( source )
		      		setElementModel (playercar,tonumber(model))
					setVehicleData ( getElementData ( playercar, "vehid" ), "model", tonumber(model) )
				else
				    outputChatBox ("Ошибка: вы не в машине",source, 255,255,127 )
				end
			else
				outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
			end
		else
			outputChatBox ("Ошибка: модель машины должна быть между 400 и 611",source, 255,255,127 )
		end
	else
		outputChatBox ("Правильно: /acarmodel модель машины",source, 255,255,127 )
	end
end

addCommandHandler ("acarmodel", adminSetCarModel)

function adminRemoveCar ( source, cmd )
	local accName = getAccountName ( getPlayerAccount ( source ) )
	if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) then
	    if(isPedInVehicle(source)) then
			local playercar = getPedOccupiedVehicle ( source )
			if isElement ( playercar ) and getElementData ( playercar, "saveable" ) then
				local id = getElementData ( playercar, "vehid" ) or 0
				local qh = dbQuery(database, "DELETE FROM cars WHERE id='"..id.."'")
				local result = dbPoll( qh, -1 ) 
				destroyElement ( playercar )
				return true
			else
				outputChatBox ("Ошибка: нельзя удалить эту машину",source, 255,255,127 )
			end
		else
			outputChatBox ("Ошибка: вы не в машине",source, 255,255,127 )
		end
	else
		outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
	end
end

addCommandHandler ("aremovecar", adminRemoveCar)

function adminSetCarColor ( source, cmd, color1, color2, color3, color4, color5, color6 )
	if(color2) then
		local accName = getAccountName ( getPlayerAccount ( source ) )
		if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "SuperModerator" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "Moderator" ) ) then
		    if(isPedInVehicle(source)) then
		   		local playercar = getPedOccupiedVehicle ( source )
    	  		setVehicleColor (playercar,color1,color2,color3,color4,color5,color6)
				setVehicleData ( getElementData ( playercar, "vehid" ), "color1", tonumber(color1) )
				setVehicleData ( getElementData ( playercar, "vehid" ), "color2", tonumber(color2) )
				setVehicleData ( getElementData ( playercar, "vehid" ), "color3", tonumber(color3) )
				setVehicleData ( getElementData ( playercar, "vehid" ), "color4", tonumber(color4) )
				setVehicleData ( getElementData ( playercar, "vehid" ), "color5", tonumber(color5) )
				setVehicleData ( getElementData ( playercar, "vehid" ), "color6", tonumber(color6) )
			else
			    outputChatBox ("Ошибка: вы не в машине",source, 255,255,127 )
			end
		else
			outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
		end
	 else
		outputChatBox ("Правильно: /acarcolor цвет 1 цвет 2",source, 255,255,127 )
	end
end

addCommandHandler ("acarcolor", adminSetCarColor)

function adminSetCarPrice ( source, cmd, carprice )
	if(carprice) then
		local accName = getAccountName ( getPlayerAccount ( source ) )
		if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "SuperModerator" ) ) then
		    if(isPedInVehicle(source)) then
		   		local playercar = getPedOccupiedVehicle ( source )
    	  		setVehicleData ( getElementData ( playercar, "vehid" ), "price", tonumber ( carprice ) )
    	  		outputChatBox ("Вы установили машине "..tostring(playercar).." цену "..tostring(carprice).." долларов",source, 243,149,72 )
			else
			    outputChatBox ("Ошибка: вы не в машине",source, 255,255,127 )
			end
		else
			outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
		end
	 else
		outputChatBox ("Правильно: /acarprice цена машины",source, 255,255,127 )
	end
end

addCommandHandler ("acarprice", adminSetCarPrice)

function adminSetCarPark ( source, cmd)
	local accName = getAccountName ( getPlayerAccount ( source ) )
	if isObjectInACLGroup ("user."..accName, aclGetGroup ( "Admin" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "SuperModerator" ) ) or isObjectInACLGroup ("user."..accName, aclGetGroup ( "Moderator" ) ) then
	    if(isPedInVehicle(source)) then
	   		local playercar = getPedOccupiedVehicle ( source )
			local x, y, z = getElementPosition ( playercar )
			local xa,ya,a = getElementRotation ( playercar )
			setVehicleData ( getElementData ( playercar, "vehid" ), "x", x )
			setVehicleData ( getElementData ( playercar, "vehid" ), "y", y )
			setVehicleData ( getElementData ( playercar, "vehid" ), "z", z )
			setVehicleData ( getElementData ( playercar, "vehid" ), "ax", xa )
			setVehicleData ( getElementData ( playercar, "vehid" ), "ay", ya )
			setVehicleData ( getElementData ( playercar, "vehid" ), "az", a )
  			outputChatBox ("Вы установили машине "..tostring(playercar).." позицию появления",source, 243,149,72 )
			setVehicleRespawnPosition ( playercar, x, y, z, xa,ya,a )
		else
		    outputChatBox ("Ошибка: вы не в машине",source, 255,255,127 )
		end
	else
		outputChatBox ("Ошибка: вы не можете использовать эту команду",source, 255,255,127 )
	end
end

addCommandHandler ("acarpark", adminSetCarPark)

function playerCarPark ( source, cmd)
    if(isPedInVehicle(source)) then
		local playercar = getPedOccupiedVehicle ( source )
		if(getElementData ( playercar, "owner" ) == getAccountName ( getPlayerAccount ( source ) )) then
			local x, y, z = getElementPosition ( playercar )
			local xa,ya,a = getElementRotation ( playercar )
			setVehicleRespawnPosition ( playercar, x, y, z, xa,ya,a )
			setVehicleData ( getElementData ( playercar, "vehid" ), "x", x )
			setVehicleData ( getElementData ( playercar, "vehid" ), "y", y )
			setVehicleData ( getElementData ( playercar, "vehid" ), "z", z )
			setVehicleData ( getElementData ( playercar, "vehid" ), "ax", xa )
			setVehicleData ( getElementData ( playercar, "vehid" ), "ay", ya )
			setVehicleData ( getElementData ( playercar, "vehid" ), "az", a )
			outputChatBox ("Вы припарковали свою машину, не забудьте её закрыть!",source, 243,149,72 )
		else
			outputChatBox ("Ошибка: это не ваша машина!",source, 255,255,127 )
		end
	else
		outputChatBox ("Ошибка: вы не в машине",source, 255,255,127 )
	end
end

addCommandHandler ("park",playerCarPark)

function playerCarSell ( source, cmd)
    if(isPedInVehicle(source)) then
	   	local playercar = getPedOccupiedVehicle ( source )
		if(getElementData ( playercar, "owner" ) == getAccountName ( getPlayerAccount ( source ) )) then
			givePlayerMoney ( source, getElementData ( playercar, "price" ) )
			outputChatBox ("Вы продали своё авто.",source, 243,149,72 )
			setControlState ( source, "enter_exit", true )
			local qh = dbQuery(database, "DELETE FROM cars WHERE owner='"..getAccountName ( getPlayerAccount ( source ) ).."'")
			local result = dbPoll( qh, -1 ) 
			destroyElement ( playercar )
		else
			outputChatBox ("Это не ваше авто.",source, 255,255,127 )
		end
    else
		outputChatBox ("Вы не в авто.",source, 255,255,127 )
	end
end

addCommandHandler ("sellmycar",playerCarSell)
